function tag_setup_TAG_RAW_OUTPUT_HANDLE(obj)
    %% create dummy data
    data = obj.gen_demo_data();

    %% setup the actual plot

    plot_handle = plot((1:size(data, 2))/obj.Scanrate, data,  '--', ...
        'Parent', obj.ParentAxis, ...
        'Tag', 'noTag', ...
        'Color', obj.plot_color, ...
        'LineWidth', obj.TAG_RAW_OUTPUT_LINE_WIDTH);

    % save handle
    obj.TAG_RAW_OUTPUT_HANDLE = plot_handle;
    createContextMenuLine(obj, obj.FBMainWindow, plot_handle);
    
end
%% EOF
