%Name = 'g5p5_03022014_t070000';
tic
Ext = 'dat';
Ku = [101 11 101 11];    %for sound recorder
Coef = single(2000./Ku/2048);  %in mV
Name_tmp = [Param.StartDir filesep Name,'.',Ext];
s = dir(Name_tmp);         
FSize = s.bytes;
fid = fopen(Name_tmp, 'r');
A = fread(fid, FSize,'uint8=>uint8');
fclose(fid);
tic
V = []; Vcount = 0;%Af = [];
Error = false;
StartPos = 1;
%Bt = zeros(1,4); 
CurrentPos = 2;
FSize_3 = FSize-3;
while CurrentPos<FSize_3  %FSize-4 -> FSize-3
   %b12 = bitxor(bitand(A(CurrentPos+1),136),128);  %no synchronization!
   %b12 = bitxor(bitand(A(CurrentPos+1),128),128); %with synchronization!
   b12 = bitand(A(CurrentPos),128); %with synchronization! rem +1 ->  1.4391s
   b34 = bitand(A(CurrentPos+3),136);
   if (b12~=0) && (b34==0)     %1.5198s; (b12==0) && (b34==0):1.7629s/1e7iter; (b12|b34)==0:1.7461s %no error  
     CurrentPos = CurrentPos+6;
     if Error 
       StartPos = CurrentPos-1;         
     end  
     Error = false;
   else             %error
     if ~Error 
       Vcount = Vcount+1;
       V(Vcount,:) = [StartPos CurrentPos-2];
       %Af = [Af; A(StartPos:CurrentPos-1)];
       %Af = [Af; TwoSeconds];   %Needed only for dev. with 2 sec start del.
                % - VERY BIG MISTAKE!!!
       Error = true;
     end;    
     CurrentPos = CurrentPos+1;  
   end;    
end;
if ~Error
  Vcount = Vcount+1;
  V(Vcount,1:2) = [StartPos CurrentPos-2]; %was -1
  %Af = [Af; A(StartPos:CurrentPos-1)]; %to copy the last part
end;
disp(['Error-free pieces: ' num2str(Vcount)]);
%here we have to collect the array indeed!!!
L = V(:,2)-V(:,1)+1;
Af_length = sum(L);
Af = zeros(Af_length,1,'uint8');
Counter = 0;
for I_t =1:size(V,1)
  Af(Counter+(1:L(I_t))) = A(V(I_t,1):V(I_t,2));
  Counter = Counter+L(I_t);
end
A = Af;
clear Af 
Am = rem(size(A,1),6)-1;
if (Am>-1)
  A((size(A,1)-Am):size(A,1),:) = [];
end;    
A = reshape(A,6,size(A,1)/6)';
B = zeros(size(A,1),4, 'single');
%Sync = zeros(size(A,1),1,'uint8');
  %bitset(A(:,2),7,0);   %remove marker of the first channel
B(:,1) = bitshift(uint16(bitand(A(:,2),112)),4)+uint16(A(:,1));  
B(:,2) = bitshift(uint16(bitand(A(:,2),7)),8)+uint16(A(:,3));
B(:,3) = bitshift(uint16(bitand(A(:,2+3),112)),4)+uint16(A(:,1+3));  
B(:,4) = bitshift(uint16(bitand(A(:,2+3),7)),8)+uint16(A(:,3+3));
Sync = bitshift(bitand(A(:,2),8),-3);
  clear A;
% M = mean(B);
% for I_t = 1:4 
%   B(:,I_t) = B(:,I_t)-M(1,I_t);
% end  
%B = B';
toc
%B = B*Coef;
%disp(num2str(median(B)));
%save([Param.StartDir filesep Name],'B','Sync','-v7.3');  %uint16, mean value 1024 
                                %(11-bit coding, the lowest bit is 0)

%figure(2);
%plot(B(:,100001:100800)');

