function [ Start_count, NPulses ] = FindStartFAllFr( Sync, Param )
k=0;
glob_fl=false;
Start_count=0;
delay_pulse=round(16*2*(Param.scanrateMax/19200)); %scanrateDesired
MinCnt = 99*Param.NStartPulses;%*2 99 for E5 - some changes in Synchronizer firmware???
MaxCnt = 109*Param.NStartPulses;%*2 109 for E5
i_start=0;
i_cur=0;
for i_t=2:(length(Sync)-1)
if ~glob_fl    
if (Sync(i_t)==1) && (Sync(i_t-1)~=Sync(i_t+1)) % rising/falling edge detection %((Sync(i-1)+Sync(i+1))==1)
    if (i_start==0)    
        i_start=i_t;
        i_cur=i_t;
    end
        if ((i_t-i_cur)<delay_pulse)
            k=k+1;
            i_cur=i_t;
        else
            if ((k>MinCnt) && (k<MaxCnt))
                glob_fl=true;
                Start_count=i_start;                
            else %set all in start position
                k=0;
                i_start=i_t;
                i_cur=i_t;
            end
        end
end 
end

end 

NPulses = k+1;

% %%
% figure(1); clf; 
% hold on
% X =-100:2000;
% plot(X,Sync(Start_count-100:Start_count+2000));
% line([0 0],[-0.1 1.1],'Color','k','LineStyle',':');
% hold off
% xlim([X(1) X(end)]);
% ylim([-0.1 1.1]);
% title(['N edges: ' num2str(k+1)]);

%      flag=flag+1
%    if (n1==0)
%        n1=i;
%    end
%    if (n2==0)
%        if (flag==2)
%            n2=i;
%        end
%    end
