function S = saveobj(obj)
% fake save method for fb_abstract.tag object
% this method is PRIVATE and is only needed for old saved objects that 
% still think that we are using the saveobj method. 

    % very dirty way to clear out trouble making listeners from old saved
    % objects.
    try 
        obj.TAG_listener_hide_handles = [];
    catch %#ok<CTCH>
        % property doesn't exist but we don't won't to make the user aware
        % of this.
    end

    try
        obj.TAG_listener_show_handles = [];
    catch %#ok<CTCH>
        % property doesn't exist but we don't won't to make the user aware
        % of this.
    end

    %% return original object
    S = obj;
    return;

end
%% EOF
