function [ NI_BP NI BP Param] = SynchronizeNI_BP( NI, BP, Param, NI_BP)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
  NI.Start_count = []; 
  NI.NPulses = [];
  [ NI.Start_count, NI.NPulses ] = FindStartFAllFr( NI.Sync, Param );
  disp(['NI Start_count: ',num2str(NI.Start_count),' NPulses: ',num2str(NI.NPulses)]);
  Param.SynchronizationTime = Param.FileStartTime+...
      double(NI.Start_count)/(Param.scanrateMax*3600*24);  
  BP.Start_count = []; 
  BP.NPulses = [];
  [ BP.Start_count, BP.NPulses ] = FindStartFAllFr( BP.Sync, Param );
  disp(['BP Start_count: ',num2str(BP.Start_count),' NPulses: ',num2str(BP.NPulses)]);
  
  Param.SynchronizationLag = 10*Param.scanrateMax;
  Param.SynchronizationFrame = 20*Param.scanrateMax;
  Param.MaxShiftAllowedEnd = round(0.004*Param.scanrateMax); %was 3.0; 0.04 - for 2013-12-14 07:00; 0.01 - only for short demo record!
  Param.MaxShiftAllowed = Param.MaxShiftAllowedEnd;
  [BP.LastNZCount NI.EndShift] = GetEndShift(NI,BP,Param); %this is just for test
  disp('Finding corresponding points...');
  [BP.CorrespondingPoints NI.Deviations] = GetCorrespondingPoints(NI,BP,Param); 
  %V = [4:46 49:58]; BP.CorrespondingPoints(V,:) = []; NI.Deviations(V,:) = [];%this is only for 2013-12-14 07:00 where whrong detection threshold was used first 9 minutes
  %V = 172:174; BP.CorrespondingPoints(V,:) = []; NI.Deviations(V,:) = [];%this is only for 2014-01-07 07:00 g7p5
  
  %save('Temp','-struct','BP','CorrespondingPoints');
  %save('Temp1','-struct','NI','Deviations');
  
%   BP.CorrespondingPoints = load('Temp');
%   NI.Deviations = load('Temp1');
%   BP.CorrespondingPoints = BP.CorrespondingPoints.CorrespondingPoints;
%   NI.Deviations = NI.Deviations.Deviations;
  disp('Shifting data...');
  NI_BP = ShiftDataF(NI,BP,NI_BP);
  %NI_BP = [];  
end

